unit sComboEdit;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, sStyleUtil, ToolEdit, CurrEdit, ComCtrls, 
  ToolWin, ExtCtrls, RXCtrls, sConst;

type

  TsComboEdit = class(TCustomComboEdit)
  private
    { Private declarations }
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
  protected
    { Protected declarations }
    FsStyle : TsStyle;
    procedure WndProc (var Message: TMessage); override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    procedure Invalidate; override;
    property Button;
    property BorderStyle;
  published
    property Alignment;
    property ButtonHint;
    property CharCase;
    property ClickKey;
    property DirectInput;
    property EditMask;
    property Enabled;
    property Font;
    property GlyphKind;
    { Ensure GlyphKind is published before Glyph and ButtonWidth }
    property Glyph;
    property ButtonWidth;
    property HideSelection;
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property NumGlyphs;
    property OEMConvert;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnButtonClick;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property OnContextPopup;
    property OnEndDock;
    property OnStartDock;

    property AutoSelect;
    property HelpContext;
    property PasswordChar;
    property Hint;
    property sStyle:TsStyle read FsStyle write FsStyle;

    property DragCursor;
    property OnEnter;
    property OnExit;
    { Published declarations }
  end;

implementation

constructor TsComboEdit.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle := TsStyle.Create(Self);
  sStyle.COC := COC_TsComboEdit;
  OnKeyDown := sStyle.OnKeyDown;
  Button.GrayedInactive := True;
  Button.Glyph.Mask(clFuchsia);
  Button.NumGlyphs := 2;
  Button.Glyph.LoadFromResourceName(hInstance, 'BTN_ELLIPSIS');
end;

procedure TsComboEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  if sStyle.Flat then begin
    InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
  end;
end;

procedure TsComboEdit.WMNCPaint(var Message: TMessage);
begin
  inherited;
  sStyle.RedrawBorder;
end;

procedure TsComboEdit.Invalidate;
begin
  if not sStyle.FDrawingStop then begin
    Color := sStyle.GetActiveColor;
    Button.Flat := sStyle.Flat;
    Button.Transparent := sStyle.Flat;
    if sStyle.Flat then begin
      Button.Left := -3;
      Button.Top := -3;
      BorderStyle := bsNone;
      if Assigned(Parent) then sStyle.RedrawBorder;
    end
    else begin
      Button.Left := 0;
      Button.Top := 0;
      BorderStyle := bsSingle;
    end;
    inherited;
  end;
end;

procedure TsComboEdit.WndProc(var Message: TMessage);
begin
   sStyle.WndProc(Message);
   inherited;
end;

end.
